# Systems Architecture Numbers

A systems architecture extension to Peter Norvig's "Latency Numbers" (http://norvig.com/21-days.html#answers).

TODO: With some scripts to export to other formats like Mnemosyne and Anki.

## CPU/Data-transfer (Norvig)
| Description                        | Value       | Unit       |
|------------------------------------|-------------|------------|
| Execute typical instruction        | 1           | nanosecond |
| Fetch from L1 cache                | 0.5         | nanosecond |
| Branch misprediction               | 5           | nanosecond |
| Fetch from L2 cache                | 7           | nanosecond |
| Mutex lock/unlock                  | 25          | nanosecond |
| Fetch from main memeory            | 100         | nanosecond |
| Send 2 KB over 1 Gbps network      | 20,000      | nanosecond |
| Read 1 MB sequentially from memory | 250,000     | nanosecond |
| Disk seek                          | 8,000,000   | nanosecond |
| Read 1 MB sequentially from disk   | 20,000,000  | nanosecond |
| Send packet round-trip US-EU       | 150,000,000 | nanosecond |

## Users

| Description                     | Value       | Unit       | Date    | Reference                                          |
|---------------------------------|-------------|------------|---------|----------------------------------------------------|
| Twitter mDAU                    | 225,000,000 | user       |         |                                                    |
| Pastebin.com monthly visitors   | 15,000,000  | visitor    |         |                                                    |
| Github repositories             | 372,000,000 | repository | 2023-01 | https://en.wikipedia.org/wiki/GitHub               |
| Github users                    | 100,000,000 | user       | 2023-01 | https://en.wikipedia.org/wiki/GitHub               |
| Youtube video average viewcount | 5,000       | view       | 2015-02 | https://tubularlabs.com/blog/average-youtube-views |


## Uncategorized

| Description            | Value | Unite       | Date | Reference                                            |
|------------------------|-------|-------------|------|------------------------------------------------------|
| Nginx TLS terminations | 750   | second/core | 2011 | https://vincent.bernat.ch/en/blog/2011-ssl-benchmark |
|                        |       |             |      |                                                      |
